#ifndef _NI_ECAT_COMMON_H
#define _NI_ECAT_COMMON_H

#define IOC_SEND           0x9001
#define IOC_RECV           0x9002
#define IOC_TIMESTAMP      0x9003
#define IOC_EPOCH_OFFSET   0x9004
#define IOC_MACADDR        0x9005
#define IOC_BRING_UP       0x9006
#define IOC_BRING_DOWN     0x9007
#define IOC_GET_BUF        0x9008
#define IOC_GET_LINKSTATE  0x9009

// Default SEND and RECV buffer descriptors (BD) numbers.
// BD Space needed is (SEND_BD_CNT+RECV_BD_CNT)*8
#define SEND_BD_CNT      128
#define RECV_BD_CNT      128

// Specify the receive buffer size in bytes, 64, 128, 192, ... 10240 
#define NIECAT_RX_BUF_SIZE      1536
#define NIECAT_TX_BUF_SIZE      1536

struct send_data_block
{
   unsigned int data_len;
   unsigned char data[NIECAT_TX_BUF_SIZE];
};

struct recv_data_block
{
   unsigned int data_len;
   unsigned char data[NIECAT_RX_BUF_SIZE];
};

#define NIECAT_MMAP_SIZE     (sizeof(struct send_data_block) \
   + sizeof(struct recv_data_block) * RECV_BD_CNT)

#endif
