#ifndef _NI_ECAT_REGS_H
#define _NI_ECAT_REGS_H

//NEW
#define NIECAT_GREGS_NBR 16
#define NIECAT_GREGS_VERSION 2

/* MACB register offsets */
#define NIECAT_NCR     0x0000 /* Network Control */
#define NIECAT_NCFGR   0x0004 /* Network Config */
#define NIECAT_NSR     0x0008 /* Network Status */
#define NIECAT_TAR     0x000c /* AT91RM9200 only */
#define NIECAT_TCR     0x0010 /* AT91RM9200 only */
#define NIECAT_TSR     0x0014 /* Transmit Status */
#define NIECAT_RBQP    0x0018 /* RX Q Base Address */
#define NIECAT_TBQP    0x001c /* TX Q Base Address */
#define NIECAT_RSR     0x0020 /* Receive Status */
#define NIECAT_ISR     0x0024 /* Interrupt Status */
#define NIECAT_IER     0x0028 /* Interrupt Enable */
#define NIECAT_IDR     0x002c /* Interrupt Disable */
#define NIECAT_IMR     0x0030 /* Interrupt Mask */
#define NIECAT_MAN     0x0034 /* PHY Maintenance */
#define NIECAT_PTR     0x0038
#define NIECAT_PFR     0x003c
#define NIECAT_FTO     0x0040
#define NIECAT_SCF     0x0044
#define NIECAT_MCF     0x0048
#define NIECAT_FRO     0x004c
#define NIECAT_FCSE    0x0050
#define NIECAT_ALE     0x0054
#define NIECAT_DTF     0x0058
#define NIECAT_LCOL    0x005c
#define NIECAT_EXCOL   0x0060
#define NIECAT_TUND    0x0064
#define NIECAT_CSE     0x0068
#define NIECAT_RRE     0x006c
#define NIECAT_ROVR    0x0070
#define NIECAT_RSE     0x0074
#define NIECAT_ELE     0x0078
#define NIECAT_RJA     0x007c
#define NIECAT_USF     0x0080
#define NIECAT_STE     0x0084
#define NIECAT_RLE     0x0088
#define NIECAT_TPF     0x008c
#define NIECAT_HRB     0x0090
#define NIECAT_HRT     0x0094
#define NIECAT_SA1B    0x0098
#define NIECAT_SA1T    0x009c
#define NIECAT_SA2B    0x00a0
#define NIECAT_SA2T    0x00a4
#define NIECAT_SA3B    0x00a8
#define NIECAT_SA3T    0x00ac
#define NIECAT_SA4B    0x00b0
#define NIECAT_SA4T    0x00b4
#define NIECAT_TID     0x00b8
#define NIECAT_TPQ     0x00bc
#define NIECAT_USRIO   0x00c0
#define NIECAT_WOL     0x00c4
#define NIECAT_MID     0x00fc

/* GEM register offsets. */
#define NIECAT_GEM_NCFGR    0x0004 /* Network Config */
#define NIECAT_GEM_USRIO    0x000c /* User IO */
#define NIECAT_GEM_DMACFG      0x0010 /* DMA Configuration */
#define NIECAT_GEM_HRB         0x0080 /* Hash Bottom */
#define NIECAT_GEM_HRT         0x0084 /* Hash Top */
#define NIECAT_GEM_SA1B     0x0088 /* Specific1 Bottom */
#define NIECAT_GEM_SA1T     0x008C /* Specific1 Top */
#define NIECAT_GEM_SA2B     0x0090 /* Specific2 Bottom */
#define NIECAT_GEM_SA2T     0x0094 /* Specific2 Top */
#define NIECAT_GEM_SA3B     0x0098 /* Specific3 Bottom */
#define NIECAT_GEM_SA3T     0x009C /* Specific3 Top */
#define NIECAT_GEM_SA4B     0x00A0 /* Specific4 Bottom */
#define NIECAT_GEM_SA4T     0x00A4 /* Specific4 Top */
#define NIECAT_GEM_OTX         0x0100 /* Octets transmitted */
#define NIECAT_GEM_OCTTXL      0x0100 /* Octets transmitted [31:0] */
#define NIECAT_GEM_OCTTXH      0x0104 /* Octets transmitted [47:32] */
#define NIECAT_GEM_TXCNT    0x0108 /* Frames Transmitted counter */
#define NIECAT_GEM_TXBCCNT     0x010c /* Broadcast Frames counter */
#define NIECAT_GEM_TXMCCNT     0x0110 /* Multicast Frames counter */
#define NIECAT_GEM_TXPAUSECNT     0x0114 /* Pause Frames Transmitted Counter */
#define NIECAT_GEM_TX64CNT     0x0118 /* 64 byte Frames TX counter */
#define NIECAT_GEM_TX65CNT     0x011c /* 65-127 byte Frames TX counter */
#define NIECAT_GEM_TX128CNT    0x0120 /* 128-255 byte Frames TX counter */
#define NIECAT_GEM_TX256CNT    0x0124 /* 256-511 byte Frames TX counter */
#define NIECAT_GEM_TX512CNT    0x0128 /* 512-1023 byte Frames TX counter */
#define NIECAT_GEM_TX1024CNT      0x012c /* 1024-1518 byte Frames TX counter */
#define NIECAT_GEM_TX1519CNT      0x0130 /* 1519+ byte Frames TX counter */
#define NIECAT_GEM_TXURUNCNT      0x0134 /* TX under run error counter */
#define NIECAT_GEM_SNGLCOLLCNT    0x0138 /* Single Collision Frame Counter */
#define NIECAT_GEM_MULTICOLLCNT   0x013c /* Multiple Collision Frame Counter */
#define NIECAT_GEM_EXCESSCOLLCNT  0x0140 /* Excessive Collision Frame Counter */
#define NIECAT_GEM_LATECOLLCNT    0x0144 /* Late Collision Frame Counter */
#define NIECAT_GEM_TXDEFERCNT     0x0148 /* Deferred Transmission Frame Counter */
#define NIECAT_GEM_TXCSENSECNT    0x014c /* Carrier Sense Error Counter */
#define NIECAT_GEM_ORX         0x0150 /* Octets received */
#define NIECAT_GEM_OCTRXL      0x0150 /* Octets received [31:0] */
#define NIECAT_GEM_OCTRXH      0x0154 /* Octets received [47:32] */
#define NIECAT_GEM_RXCNT    0x0158 /* Frames Received Counter */
#define NIECAT_GEM_RXBROADCNT     0x015c /* Broadcast Frames Received Counter */
#define NIECAT_GEM_RXMULTICNT     0x0160 /* Multicast Frames Received Counter */
#define NIECAT_GEM_RXPAUSECNT     0x0164 /* Pause Frames Received Counter */
#define NIECAT_GEM_RX64CNT     0x0168 /* 64 byte Frames RX Counter */
#define NIECAT_GEM_RX65CNT     0x016c /* 65-127 byte Frames RX Counter */
#define NIECAT_GEM_RX128CNT    0x0170 /* 128-255 byte Frames RX Counter */
#define NIECAT_GEM_RX256CNT    0x0174 /* 256-511 byte Frames RX Counter */
#define NIECAT_GEM_RX512CNT    0x0178 /* 512-1023 byte Frames RX Counter */
#define NIECAT_GEM_RX1024CNT      0x017c /* 1024-1518 byte Frames RX Counter */
#define NIECAT_GEM_RX1519CNT      0x0180 /* 1519+ byte Frames RX Counter */
#define NIECAT_GEM_RXUNDRCNT      0x0184 /* Undersize Frames Received Counter */
#define NIECAT_GEM_RXOVRCNT    0x0188 /* Oversize Frames Received Counter */
#define NIECAT_GEM_RXJABCNT    0x018c /* Jabbers Received Counter */
#define NIECAT_GEM_RXFCSCNT    0x0190 /* Frame Check Sequence Error Counter */
#define NIECAT_GEM_RXLENGTHCNT    0x0194 /* Length Field Error Counter */
#define NIECAT_GEM_RXSYMBCNT      0x0198 /* Symbol Error Counter */
#define NIECAT_GEM_RXALIGNCNT     0x019c /* Alignment Error Counter */
#define NIECAT_GEM_RXRESERRCNT    0x01a0 /* Receive Resource Error Counter */
#define NIECAT_GEM_RXORCNT     0x01a4 /* Receive Overrun Counter */
#define NIECAT_GEM_RXIPCCNT    0x01a8 /* IP header Checksum Error Counter */
#define NIECAT_GEM_RXTCPCCNT      0x01ac /* TCP Checksum Error Counter */
#define NIECAT_GEM_RXUDPCCNT      0x01b0 /* UDP Checksum Error Counter */
#define NIECAT_GEM_DCFG1    0x0280 /* Design Config 1 */
#define NIECAT_GEM_DCFG2    0x0284 /* Design Config 2 */
#define NIECAT_GEM_DCFG3    0x0288 /* Design Config 3 */
#define NIECAT_GEM_DCFG4    0x028c /* Design Config 4 */
#define NIECAT_GEM_DCFG5    0x0290 /* Design Config 5 */
#define NIECAT_GEM_DCFG6    0x0294 /* Design Config 6 */
#define NIECAT_GEM_DCFG7    0x0298 /* Design Config 7 */

#define NIECAT_GEM_ISR(hw_q)      (0x0400 + ((hw_q) << 2))
#define NIECAT_GEM_TBQP(hw_q)     (0x0440 + ((hw_q) << 2))
#define NIECAT_GEM_RBQP(hw_q)     (0x0480 + ((hw_q) << 2))
#define NIECAT_GEM_IER(hw_q)      (0x0600 + ((hw_q) << 2))
#define NIECAT_GEM_IDR(hw_q)      (0x0620 + ((hw_q) << 2))
#define NIECAT_GEM_IMR(hw_q)      (0x0640 + ((hw_q) << 2))

/* Bitfields in NCR */
#define NIECAT_LB_OFFSET     0 /* reserved */
#define NIECAT_LB_SIZE    1
#define NIECAT_LLB_OFFSET    1 /* Loop back local */
#define NIECAT_LLB_SIZE      1
#define NIECAT_RE_OFFSET     2 /* Receive enable */
#define NIECAT_RE_SIZE    1
#define NIECAT_TE_OFFSET     3 /* Transmit enable */
#define NIECAT_TE_SIZE    1
#define NIECAT_MPE_OFFSET    4 /* Management port enable */
#define NIECAT_MPE_SIZE      1
#define NIECAT_CLRSTAT_OFFSET   5 /* Clear stats regs */
#define NIECAT_CLRSTAT_SIZE  1
#define NIECAT_INCSTAT_OFFSET   6 /* Incremental stats regs */
#define NIECAT_INCSTAT_SIZE  1
#define NIECAT_WESTAT_OFFSET 7 /* Write enable stats regs */
#define NIECAT_WESTAT_SIZE   1
#define NIECAT_BP_OFFSET     8 /* Back pressure */
#define NIECAT_BP_SIZE    1
#define NIECAT_TSTART_OFFSET 9 /* Start transmission */
#define NIECAT_TSTART_SIZE   1
#define NIECAT_THALT_OFFSET  10 /* Transmit halt */
#define NIECAT_THALT_SIZE    1
#define NIECAT_NCR_TPF_OFFSET   11 /* Transmit pause frame */
#define NIECAT_NCR_TPF_SIZE  1
#define NIECAT_TZQ_OFFSET    12 /* Transmit zero quantum pause frame */
#define NIECAT_TZQ_SIZE      1

/* Bitfields in NCFGR */
#define NIECAT_SPD_OFFSET    0 /* Speed */
#define NIECAT_SPD_SIZE      1
#define NIECAT_FD_OFFSET     1 /* Full duplex */
#define NIECAT_FD_SIZE    1
#define NIECAT_BIT_RATE_OFFSET  2 /* Discard non-VLAN frames */
#define NIECAT_BIT_RATE_SIZE 1
#define NIECAT_JFRAME_OFFSET 3 /* reserved */
#define NIECAT_JFRAME_SIZE   1
#define NIECAT_CAF_OFFSET    4 /* Copy all frames */
#define NIECAT_CAF_SIZE      1
#define NIECAT_NBC_OFFSET    5 /* No broadcast */
#define NIECAT_NBC_SIZE      1
#define NIECAT_NCFGR_MTI_OFFSET 6 /* Multicast hash enable */
#define NIECAT_NCFGR_MTI_SIZE   1
#define NIECAT_UNI_OFFSET    7 /* Unicast hash enable */
#define NIECAT_UNI_SIZE      1
#define NIECAT_BIG_OFFSET    8 /* Receive 1536 byte frames */
#define NIECAT_BIG_SIZE      1
#define NIECAT_EAE_OFFSET    9 /* External address match enable */
#define NIECAT_EAE_SIZE      1
#define NIECAT_CLK_OFFSET    10
#define NIECAT_CLK_SIZE      2
#define NIECAT_RTY_OFFSET    12 /* Retry test */
#define NIECAT_RTY_SIZE      1
#define NIECAT_PAE_OFFSET    13 /* Pause enable */
#define NIECAT_PAE_SIZE      1
#define NIECAT_RM9200_RMII_OFFSET  13 /* AT91RM9200 only */
#define NIECAT_RM9200_RMII_SIZE 1  /* AT91RM9200 only */
#define NIECAT_RBOF_OFFSET   14 /* Receive buffer offset */
#define NIECAT_RBOF_SIZE     2
#define NIECAT_RLCE_OFFSET   16 /* Length field error frame discard */
#define NIECAT_RLCE_SIZE     1
#define NIECAT_DRFCS_OFFSET  17 /* FCS remove */
#define NIECAT_DRFCS_SIZE    1
#define NIECAT_EFRHD_OFFSET  18
#define NIECAT_EFRHD_SIZE    1
#define NIECAT_IRXFCS_OFFSET 19
#define NIECAT_IRXFCS_SIZE   1
#define NIECAT_PSE_OFFSET               23
#define NIECAT_PSE_SIZE                 1
#define NIECAT_RXCHKS_OFFSET            24
#define NIECAT_RXCHKS_SIZE              1
#define NIECAT_HDRXEN_OFFSET            25
#define NIECAT_HDRXEN_SIZE              1

/* GEM specific NCFGR bitfields. */
#define NIECAT_GEM_GBE_OFFSET     10 /* Gigabit mode enable */
#define NIECAT_GEM_GBE_SIZE    1
#define NIECAT_GEM_CLK_OFFSET     18 /* MDC clock division */
#define NIECAT_GEM_CLK_SIZE    3
#define NIECAT_GEM_DBW_OFFSET     21 /* Data bus width */
#define NIECAT_GEM_DBW_SIZE    2
#define NIECAT_GEM_RXCOEN_OFFSET  24
#define NIECAT_GEM_RXCOEN_SIZE    1

/* Constants for data bus width. */
#define NIECAT_GEM_DBW32    0 /* 32 bit AMBA AHB data bus width */
#define NIECAT_GEM_DBW64    1 /* 64 bit AMBA AHB data bus width */
#define NIECAT_GEM_DBW128      2 /* 128 bit AMBA AHB data bus width */

/* Bitfields in DMACFG. */
#define NIECAT_GEM_FBLDO_OFFSET   0 /* fixed burst length for DMA */
#define NIECAT_GEM_FBLDO_SIZE     5
#define NIECAT_GEM_INCR16_OFFSET  4
#define NIECAT_GEM_INCR16_SIZE    1
#define NIECAT_GEM_ENDIA_OFFSET   7 /* endian swap mode for packet data access */
#define NIECAT_GEM_ENDIA_SIZE     1
#define NIECAT_GEM_RXBMS_OFFSET   8 /* RX packet buffer memory size select */
#define NIECAT_GEM_RXBMS_SIZE     2
#define NIECAT_GEM_TXPBMS_OFFSET  10 /* TX packet buffer memory size select */
#define NIECAT_GEM_TXPBMS_SIZE    1
#define NIECAT_GEM_TXCOEN_OFFSET  11 /* TX IP/TCP/UDP checksum gen offload */
#define NIECAT_GEM_TXCOEN_SIZE    1
#define NIECAT_GEM_RXBS_OFFSET    16 /* DMA receive buffer size */
#define NIECAT_GEM_RXBS_SIZE      8
#define NIECAT_GEM_DDRP_OFFSET    24 /* disc_when_no_ahb */
#define NIECAT_GEM_DDRP_SIZE      1


/* Bitfields in NSR */
#define NIECAT_NSR_LINK_OFFSET  0 /* pcs_link_state */
#define NIECAT_NSR_LINK_SIZE 1
#define NIECAT_MDIO_OFFSET   1 /* status of the mdio_in pin */
#define NIECAT_MDIO_SIZE     1
#define NIECAT_IDLE_OFFSET   2 /* The PHY management logic is idle */
#define NIECAT_IDLE_SIZE     1

/* Bitfields in TSR */
#define NIECAT_UBR_OFFSET    0 /* Used bit read */
#define NIECAT_UBR_SIZE      1
#define NIECAT_COL_OFFSET    1 /* Collision occurred */
#define NIECAT_COL_SIZE      1
#define NIECAT_TSR_RLE_OFFSET   2 /* Retry limit exceeded */
#define NIECAT_TSR_RLE_SIZE  1
#define NIECAT_TGO_OFFSET    3 /* Transmit go */
#define NIECAT_TGO_SIZE      1
#define NIECAT_BEX_OFFSET    4 /* TX frame corruption due to AHB error */
#define NIECAT_BEX_SIZE      1
#define NIECAT_RM9200_BNQ_OFFSET   4 /* AT91RM9200 only */
#define NIECAT_RM9200_BNQ_SIZE  1 /* AT91RM9200 only */
#define NIECAT_COMP_OFFSET   5 /* Trnasmit complete */
#define NIECAT_COMP_SIZE     1
#define NIECAT_UND_OFFSET    6 /* Trnasmit under run */
#define NIECAT_UND_SIZE      1

/* Bitfields in RSR */
#define NIECAT_BNA_OFFSET    0 /* Buffer not available */
#define NIECAT_BNA_SIZE      1
#define NIECAT_REC_OFFSET    1 /* Frame received */
#define NIECAT_REC_SIZE      1
#define NIECAT_OVR_OFFSET    2 /* Receive overrun */
#define NIECAT_OVR_SIZE      1

/* Bitfields in ISR/IER/IDR/IMR */
#define NIECAT_MFD_OFFSET    0 /* Management frame sent */
#define NIECAT_MFD_SIZE      1
#define NIECAT_RCOMP_OFFSET  1 /* Receive complete */
#define NIECAT_RCOMP_SIZE    1
#define NIECAT_RXUBR_OFFSET  2 /* RX used bit read */
#define NIECAT_RXUBR_SIZE    1
#define NIECAT_TXUBR_OFFSET  3 /* TX used bit read */
#define NIECAT_TXUBR_SIZE    1
#define NIECAT_ISR_TUND_OFFSET  4 /* Enable TX buffer under run interrupt */
#define NIECAT_ISR_TUND_SIZE 1
#define NIECAT_ISR_RLE_OFFSET   5 /* EN retry exceeded/late coll interrupt */
#define NIECAT_ISR_RLE_SIZE  1
#define NIECAT_TXERR_OFFSET  6 /* EN TX frame corrupt from error interrupt */
#define NIECAT_TXERR_SIZE    1
#define NIECAT_TCOMP_OFFSET  7 /* Enable transmit complete interrupt */
#define NIECAT_TCOMP_SIZE    1
#define NIECAT_ISR_LINK_OFFSET  9 /* Enable link change interrupt */
#define NIECAT_ISR_LINK_SIZE 1
#define NIECAT_ISR_ROVR_OFFSET  10 /* Enable receive overrun interrupt */
#define NIECAT_ISR_ROVR_SIZE 1
#define NIECAT_HRESP_OFFSET  11 /* Enable hrsep not OK interrupt */
#define NIECAT_HRESP_SIZE    1
#define NIECAT_PFR_OFFSET    12 /* Enable pause frame w/ quantum interrupt */
#define NIECAT_PFR_SIZE      1
#define NIECAT_PTZ_OFFSET    13 /* Enable pause time zero interrupt */
#define NIECAT_PTZ_SIZE      1

/* Bitfields in MAN */
#define NIECAT_DATA_OFFSET   0 /* data */
#define NIECAT_DATA_SIZE     16
#define NIECAT_CODE_OFFSET   16 /* Must be written to 10 */
#define NIECAT_CODE_SIZE     2
#define NIECAT_REGA_OFFSET   18 /* Register address */
#define NIECAT_REGA_SIZE     5
#define NIECAT_PHYA_OFFSET   23 /* PHY address */
#define NIECAT_PHYA_SIZE     5
#define NIECAT_RW_OFFSET     28 /* Operation. 10 is read. 01 is write. */
#define NIECAT_RW_SIZE    2
#define NIECAT_SOF_OFFSET    30 /* Must be written to 1 for Clause 22 */
#define NIECAT_SOF_SIZE      2

/* Bitfields in USRIO (AVR32) */
#define NIECAT_MII_OFFSET          0
#define NIECAT_MII_SIZE            1
#define NIECAT_EAM_OFFSET          1
#define NIECAT_EAM_SIZE            1
#define NIECAT_TX_PAUSE_OFFSET        2
#define NIECAT_TX_PAUSE_SIZE       1
#define NIECAT_TX_PAUSE_ZERO_OFFSET      3
#define NIECAT_TX_PAUSE_ZERO_SIZE        1

/* Bitfields in USRIO (AT91) */
#define NIECAT_RMII_OFFSET         0
#define NIECAT_RMII_SIZE           1
#define NIECAT_GEM_RGMII_OFFSET         0 /* GEM gigabit mode */
#define NIECAT_GEM_RGMII_SIZE           1
#define NIECAT_CLKEN_OFFSET        1
#define NIECAT_CLKEN_SIZE          1

/* Bitfields in WOL */
#define NIECAT_IP_OFFSET           0
#define NIECAT_IP_SIZE          16
#define NIECAT_MAG_OFFSET          16
#define NIECAT_MAG_SIZE            1
#define NIECAT_ARP_OFFSET          17
#define NIECAT_ARP_SIZE            1
#define NIECAT_SA1_OFFSET          18
#define NIECAT_SA1_SIZE            1
#define NIECAT_WOL_MTI_OFFSET         19
#define NIECAT_WOL_MTI_SIZE        1

/* Bitfields in MID */
#define NIECAT_IDNUM_OFFSET        16
#define NIECAT_IDNUM_SIZE          16
#define NIECAT_REV_OFFSET          0
#define NIECAT_REV_SIZE            16

/* Bitfields in DCFG1. */
#define NIECAT_GEM_IRQCOR_OFFSET        23
#define NIECAT_GEM_IRQCOR_SIZE          1
#define NIECAT_GEM_DBWDEF_OFFSET        25
#define NIECAT_GEM_DBWDEF_SIZE          3

/* Constants for CLK */
#define NIECAT_CLK_DIV8            0
#define NIECAT_CLK_DIV16           1
#define NIECAT_CLK_DIV32           2
#define NIECAT_CLK_DIV64           3

/* GEM specific constants for CLK. */
#define NIECAT_GEM_CLK_DIV8          0
#define NIECAT_GEM_CLK_DIV16            1
#define NIECAT_GEM_CLK_DIV32            2
#define NIECAT_GEM_CLK_DIV48            3
#define NIECAT_GEM_CLK_DIV64            4
#define NIECAT_GEM_CLK_DIV96            5

/* Constants for MAN register */
#define NIECAT_MAN_SOF          1
#define NIECAT_MAN_WRITE           1
#define NIECAT_MAN_READ            2
#define NIECAT_MAN_CODE            2

/* Capability mask bits */
#define NIECAT_CAPS_ISR_CLEAR_ON_WRITE      0x1

/* DMA descriptor bitfields */
#define NIECAT_RX_USED_OFFSET         0
#define NIECAT_RX_USED_SIZE        1
#define NIECAT_RX_WRAP_OFFSET         1
#define NIECAT_RX_WRAP_SIZE        1
#define NIECAT_RX_WADDR_OFFSET        2
#define NIECAT_RX_WADDR_SIZE       30

#define NIECAT_RX_FRMLEN_OFFSET       0
#define NIECAT_RX_FRMLEN_SIZE         12
#define NIECAT_RX_OFFSET_OFFSET       12
#define NIECAT_RX_OFFSET_SIZE         2
#define NIECAT_RX_BAD_OFFSET            13
#define NIECAT_RX_BAD_SIZE              1
#define NIECAT_RX_SOF_OFFSET       14
#define NIECAT_RX_SOF_SIZE         1
#define NIECAT_RX_EOF_OFFSET       15
#define NIECAT_RX_EOF_SIZE         1
#define NIECAT_RX_CFI_OFFSET       16
#define NIECAT_RX_CFI_SIZE         1
#define NIECAT_RX_VLAN_PRI_OFFSET        17
#define NIECAT_RX_VLAN_PRI_SIZE       3
#define NIECAT_RX_PRI_TAG_OFFSET         20
#define NIECAT_RX_PRI_TAG_SIZE        1
#define NIECAT_RX_VLAN_TAG_OFFSET        21
#define NIECAT_RX_VLAN_TAG_SIZE       1
#define NIECAT_RX_TYPEID_MATCH_OFFSET    22
#define NIECAT_RX_TYPEID_MATCH_SIZE      1
#define NIECAT_RX_SA4_MATCH_OFFSET    23
#define NIECAT_RX_SA4_MATCH_SIZE         1
#define NIECAT_RX_SA3_MATCH_OFFSET    24
#define NIECAT_RX_SA3_MATCH_SIZE         1
#define NIECAT_RX_SA2_MATCH_OFFSET    25
#define NIECAT_RX_SA2_MATCH_SIZE         1
#define NIECAT_RX_SA1_MATCH_OFFSET    26
#define NIECAT_RX_SA1_MATCH_SIZE         1
#define NIECAT_RX_EXT_MATCH_OFFSET    28
#define NIECAT_RX_EXT_MATCH_SIZE         1
#define NIECAT_RX_UHASH_MATCH_OFFSET     29
#define NIECAT_RX_UHASH_MATCH_SIZE    1
#define NIECAT_RX_MHASH_MATCH_OFFSET     30
#define NIECAT_RX_MHASH_MATCH_SIZE    1
#define NIECAT_RX_BROADCAST_OFFSET    31
#define NIECAT_RX_BROADCAST_SIZE         1

#define NIECAT_TX_FRMLEN_OFFSET       0
#define NIECAT_TX_FRMLEN_SIZE         11
#define NIECAT_TX_LAST_OFFSET         15
#define NIECAT_TX_LAST_SIZE        1
#define NIECAT_TX_NOCRC_OFFSET        16
#define NIECAT_TX_NOCRC_SIZE       1
#define NIECAT_TX_BUF_EXHAUSTED_OFFSET      27
#define NIECAT_TX_BUF_EXHAUSTED_SIZE     1
#define NIECAT_TX_UNDERRUN_OFFSET        28
#define NIECAT_TX_UNDERRUN_SIZE       1
#define NIECAT_TX_ERROR_OFFSET        29
#define NIECAT_TX_ERROR_SIZE       1
#define NIECAT_TX_WRAP_OFFSET         30
#define NIECAT_TX_WRAP_SIZE        1
#define NIECAT_TX_USED_OFFSET         31
#define NIECAT_TX_USED_SIZE        1

#define NIECAT_GEM_TX_FRMLEN_OFFSET        0
#define NIECAT_GEM_TX_FRMLEN_SIZE       14

/* Buffer descriptor constants */
#define NIECAT_GEM_RX_CSUM_NONE         0
#define NIECAT_GEM_RX_CSUM_IP_ONLY         1
#define NIECAT_GEM_RX_CSUM_IP_TCP       2
#define NIECAT_GEM_RX_CSUM_IP_UDP       3

/* limit RX checksum offload to TCP and UDP packets */
#define NIECAT_GEM_RX_CSUM_CHECKED_MASK    2

/* Bit manipulation macros */
#define NIECAT_BIT(name)              \
   (1 << NIECAT_##name##_OFFSET)
#define NIECAT_F(name)          \
   (((1 << NIECAT_##name##_SIZE) - 1)    \
    << NIECAT_##name##_OFFSET)
#define NIECAT_BF(name,value)            \
   (((value) & ((1 << NIECAT_##name##_SIZE) - 1)) \
    << NIECAT_##name##_OFFSET)
#define NIECAT_BFEXT(name,value)\
   (((value) >> NIECAT_##name##_OFFSET)     \
    & ((1 << NIECAT_##name##_SIZE) - 1))
#define NIECAT_BFINS(name,value,old)        \
   (((old) & ~(((1 << NIECAT_##name##_SIZE) - 1)  \
          << NIECAT_##name##_OFFSET))    \
    | NIECAT_BF(name,value))

#define NIECAT_GEM_BIT(name)               \
   (1 << NIECAT_GEM_##name##_OFFSET)
#define NIECAT_GEM_F(name)           \
   (((1 << NIECAT_GEM_##name##_SIZE) - 1)        \
    << NIECAT_GEM_##name##_OFFSET)
#define NIECAT_GEM_BF(name, value)            \
   (((value) & ((1 << NIECAT_GEM_##name##_SIZE) - 1))  \
    << NIECAT_GEM_##name##_OFFSET)
#define NIECAT_GEM_BFEXT(name, value)\
   (((value) >> NIECAT_GEM_##name##_OFFSET)      \
    & ((1 << NIECAT_GEM_##name##_SIZE) - 1))
#define NIECAT_GEM_BFINS(name, value, old)       \
   (((old) & ~(((1 << NIECAT_GEM_##name##_SIZE) - 1)   \
          << NIECAT_GEM_##name##_OFFSET))     \
    | NIECAT_GEM_BF(name, value))

/* Register access macros */
#define niecat_readl(port,reg)          \
   readl_relaxed((port)->regs + NIECAT_##reg)
#define niecat_writel(port,reg,value)         \
   writel_relaxed((value), (port)->regs + NIECAT_##reg)
#define niecat_gem_readl(port, reg)          \
   readl_relaxed((port)->regs + NIECAT_GEM_##reg)
#define niecat_gem_writel(port, reg, value)        \
   writel_relaxed((value), (port)->regs + NIECAT_GEM_##reg)

/* Conditional GEM/MACB macros.  These perform the operation to the correct
 * register dependent on whether the device is a GEM or a MACB.  For registers
 * and bitfields that are common across both devices, use niecat_{read,write}l
 * to avoid the cost of the conditional.
 */
#define niecat_or_gem_writel(__bp, __reg, __value) \
   ({ \
      if (NIECAT_BFEXT(IDNUM, niecat_readl((__bp), MID)) == 0x2) \
         niecat_gem_writel((__bp), __reg, __value); \
      else \
         niecat_writel((__bp), __reg, __value); \
   })

#define niecat_or_gem_readl(__bp, __reg) \
   ({ \
      u32 __v; \
      if (NIECAT_BFEXT(IDNUM, niecat_readl((__bp), MID)) == 0x2) \
         __v = niecat_gem_readl((__bp), __reg); \
      else \
         __v = niecat_readl((__bp), __reg); \
      __v; \
   })
   
#endif /* _NI_ECAT_REGS_H */